/* Musical Blob
 * University of Washington Computer Science and Engineering
 * Sound Capstone (CSE 481i)
 * Project Members: Nathan Armstrong, Daniel Chesney, Andrew Foster
 *
 * BoundingBox
 * Represents a simple bounding box, with built-in intersection testing.
 */

#ifndef __BOUNDING_BOX_HPP__
#define __BOUNDING_BOX_HPP__

#include "TripleD.hpp"

class BoundingBox{
public:
	//Creates a new BoundingBox with all corners at (0,0,0)
	BoundingBox() : minP(), maxP() {}
	//Creates a new BoundingBox with the given minimum and maximum points.
	BoundingBox(const TripleD& minCorner, const TripleD& maxCorner)
		: minP(minCorner), maxP(maxCorner) {}
	//Creates a new BoundingBox that encompasses the two given BoundingBoxes
	//as tightly as possible.
	BoundingBox(const BoundingBox& a, const BoundingBox& b);

	//Accessors
	TripleD getMinCorner() const { return minP; }
	TripleD getMaxCorner() const { return maxP; }

	//Returns whether this bounding box intersects the given box.
	bool intersects(const BoundingBox& o) const;

private:
	TripleD minP, maxP;
};

#endif